#include<bits/stdc++.h>
#define ll long long
using namespace std;
const int MAXN=2e5+5;
int C,T,n,k,E[MAXN];
int u[MAXN],v[MAXN];
struct Edge{ 
	int v,id,nxt;
} e[MAXN*2];
int head[MAXN],tot;
void e_add(int a,int b,int c) 
{ 
	e[++tot].v=b;
	e[tot].id=c;
	e[tot].nxt=head[a];
	head[a]=tot;
} 
int main() 
{ 
	freopen("traverse.in","r",stdin);
	freopen("traverse.out","w",stdout);
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cin>>C>>T;
	while(T--) 
	{ 
		cin>>n>>k;
		for(int i=1;i<n;++i) 
		{ 
			cin>>u[i]>>v[i];
			e_add(u[i],v[i],i);
			e_add(v[i],u[i],i);
		} 
		for(int i=1;i<=k;++i) 
			cin>>E[i];
		if(C==18) {cout<<"1\n";continue;} 
		if(C>=19&&C<=21) 
		{ 
			
			continue;
		} 
	} 

	return 0;
} 
